Subject: Re: bug#71429: Inconsistent y-or-n-p prompt behavior in Emacs Lisp

From: Eli Zaretskii <[email-masked]>
Date: Sat, 08 Jun 2024 11:24:50 +0300

> Date: Sat, 8 Jun 2024 09:03:37 +0200
> From: Gabriele Nicolardi <[email-masked]>
> 
> I have the following Emacs Lisp code:
> 
> (progn
>   (y-or-n-p "Test: ")
>   (let ((search-spaces-regexp "\\(?:\\n?[\s\t]+\\|\n\\)?"))
>     (y-or-n-p "Test: ")))
> 
> The first prompt from the y-or-n-p function appears as expected:
> 
> Test: (y or n)
> 
> However, the second prompt appears differently:
> 
> Test: (‘y’ or ‘n’)
> 
> I’m trying to understand why the second prompt format changes. What causes this inconsistency in the
> y-or-n-p prompt?
> 
> I suspect it might be related to the search-spaces-regexp variable or how Emacs handles interactive
> prompts, but I’m not sure. Any insights or explanations would be greatly appreciated!

Stefan, can you please look into this?  It sounds like some issue with
substitute-command-keys:

  (substitute-command-keys "(\\`y' or \\`n') ")
   => #("(y or n) " 1 2 (font-lock-face help-key-binding face help-key-binding) 6 7 (font-lock-face help-key-binding face help-key-binding))

But

  (let ((search-spaces-regexp "\\(?:\\n?[\s\t]+\\|\n\\)?"))
    (substitute-command-keys "(\\`y' or \\`n') "))
   => "(\\‘y’ or \\‘n’) "

I actually don't understand why we use \\`y' and \\`n' in y-or-n-p.
Why those backslashes, and not just `y' and `n'?  That's your change
in commit a36ecc408a.  If I remove the backslashes, the results are
identical whether or not search-spaces-regexp is let-bound.